Bug 829689 - mod_ldap: fix occasional 500 Internal Server Error
mod_ldap: fix occasional 500 Internal Server Error
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: httpd (Show other bugs)
6.2
Unspecified Unspecified
medium Severity medium
: rc
: ---
Assigned To: Jan Kaluža
Zbysek MRAZ
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-06-07 06:25 EDT by Filip Valder
Modified: 2013-07-03 09:15 EDT (History)
4 users (show)

See Also:
Fixed In Version: httpd-2.2.15-17.el6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-02-21 05:17:18 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
httpd-2.2.15-ldapna.patch (3.21 KB, patch)
2012-06-07 06:25 EDT, Filip Valder
no flags Details | Diff
httpd.spec.diff (862 bytes, patch)
2012-06-07 06:26 EDT, Filip Valder
no flags Details | Diff


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2013:0512 normal SHIPPED_LIVE Low: httpd security, bug fix, and enhancement update 2013-02-20 16:29:30 EST

  None (edit)
Description Filip Valder 2012-06-07 06:25:04 EDT
Created attachment 590152 [details]
httpd-2.2.15-ldapna.patch

Hi.

It happens that our LDAP server (Novell eDirectory) SOMEHOW gets unavailable and it causes 500 Internal Server Error on an authenticated page after filling in user credentials. After reloading page using <F5>, the LDAP-protected content finally appears.

The problem exists only a few seconds after httpd is idle for several minutes. Then it works continuously without any problem until next idle time of httpd.

The httpd debug message is:
auth_ldap authenticate: user  authentication failed; URI XXX [ldap_search_ext_s() for user failed][Server is unavailable]

The cause of this problem is given by this condition in util_ldap.h:
#if APR_HAS_MICROSOFT_LDAPSDK
#define AP_LDAP_IS_SERVER_DOWN(s)                ((s) == LDAP_SERVER_DOWN \
                ||(s) == LDAP_UNAVAILABLE)
#else
#define AP_LDAP_IS_SERVER_DOWN(s)                ((s) == LDAP_SERVER_DOWN)
#endif

I've simplified it:
#define AP_LDAP_IS_SERVER_DOWN(s)                ((s) == LDAP_SERVER_DOWN \
                ||(s) == LDAP_UNAVAILABLE)

I'm attaching a patch, so you can try it. I'm using siege for testing and after applying the patch, the error 500 disappeared.

Cheers.
Filip
Comment 1 Filip Valder 2012-06-07 06:26:41 EDT
Created attachment 590153 [details]
httpd.spec.diff
Comment 3 Joe Orton 2012-06-08 08:20:23 EDT
Thanks Filip.  I've pushed this fix upstream:

http://svn.apache.org/viewvc?view=revision&revision=1348036
Comment 4 David Hrbáč 2012-06-11 05:42:19 EDT
I can confirm the patch resolves the issue.
Comment 5 RHEL Product and Program Management 2012-07-10 04:30:58 EDT
This request was not resolved in time for the current release.
Red Hat invites you to ask your support representative to
propose this request, if still desired, for consideration in
the next release of Red Hat Enterprise Linux.
Comment 6 RHEL Product and Program Management 2012-07-10 19:23:25 EDT
This request was erroneously removed from consideration in Red Hat Enterprise Linux 6.4, which is currently under development.  This request will be evaluated for inclusion in Red Hat Enterprise Linux 6.4.
Comment 11 errata-xmlrpc 2013-02-21 05:17:18 EST
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHSA-2013-0512.html

Note You need to log in before you can comment on or make changes to this bug.